/*
 *  Power BI Visualizations
 *
 *  Copyright (c) Microsoft Corporation
 *  All rights reserved.
 *  MIT License
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the ""Software""), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED *AS IS*, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *  THE SOFTWARE.
 */
//// <reference path="../../_references.ts"/>
var powerbi;
(function (powerbi) {
    var visuals;
    (function (visuals) {
        var BulletChart1443347686880;
        (function (BulletChart1443347686880) {
            var PixelConverter = jsCommon.PixelConverter;
            BulletChart1443347686880.bulletChartProps = {
                values: {
                    targetValue: { objectName: 'values', propertyName: 'targetValue' },
                    minimumPercent: { objectName: 'values', propertyName: 'minimumPercent' },
                    needsImprovementPercent: { objectName: 'values', propertyName: 'needsImprovementPercent' },
                    satisfactoryPercent: { objectName: 'values', propertyName: 'satisfactoryPercent' },
                    goodPercent: { objectName: 'values', propertyName: 'goodPercent' },
                    veryGoodPercent: { objectName: 'values', propertyName: 'veryGoodPercent' },
                    maximumPercent: { objectName: 'values', propertyName: 'maximumPercent' },
                    targetValue2: { objectName: 'values', propertyName: 'targetValue2' },
                },
                orientation: {
                    orientation: { objectName: 'orientation', propertyName: 'orientation' },
                },
                colors: {
                    badColor: { objectName: 'colors', propertyName: 'badColor' },
                    needsImprovementColor: { objectName: 'colors', propertyName: 'needsImprovementColor' },
                    satisfactoryColor: { objectName: 'colors', propertyName: 'satisfactoryColor' },
                    goodColor: { objectName: 'colors', propertyName: 'goodColor' },
                    veryGoodColor: { objectName: 'colors', propertyName: 'veryGoodColor' },
                    bulletColor: { objectName: 'colors', propertyName: 'bulletColor' },
                },
                axis: {
                    axis: { objectName: 'axis', propertyName: 'axis' },
                    axisColor: { objectName: 'axis', propertyName: 'axisColor' },
                    measureUnits: { objectName: 'axis', propertyName: 'measureUnits' },
                    unitsColor: { objectName: 'axis', propertyName: 'unitsColor' },
                },
                formatString: { objectName: 'general', propertyName: 'formatString' },
                labels: {
                    fontSize: { objectName: 'labels', propertyName: 'fontSize' },
                    show: { objectName: 'labels', propertyName: 'show' },
                    labelColor: { objectName: 'labels', propertyName: 'labelColor' }
                }
            };
            BulletChart1443347686880.bulletChartRoleNames = {
                value: 'Value',
                targetValue: 'TargetValue',
                minValue: 'Minimum',
                needsImprovementValue: 'NeedsImprovement',
                satisfactoryValue: 'Satisfactory',
                goodValue: 'Good',
                veryGoodValue: 'VeryGood',
                maxValue: 'Maximum',
                targetValue2: 'TargetValue2',
            };
            var Orientation;
            (function (Orientation) {
                Orientation.HORIZONTALLEFT = 'Horizontal Left';
                Orientation.HORIZONTALRIGHT = 'Horizontal Right';
                Orientation.VERTICALTOP = 'Vertical Top';
                Orientation.VERTICALBOTTOM = 'Vertical Bottom';
                Orientation.type = powerbi.createEnumType([
                    { value: Orientation.HORIZONTALLEFT, displayName: Orientation.HORIZONTALLEFT },
                    { value: Orientation.HORIZONTALRIGHT, displayName: Orientation.HORIZONTALRIGHT },
                    { value: Orientation.VERTICALTOP, displayName: Orientation.VERTICALTOP },
                    { value: Orientation.VERTICALBOTTOM, displayName: Orientation.VERTICALBOTTOM }
                ]);
            })(Orientation || (Orientation = {}));
            var BulletChart = (function () {
                function BulletChart() {
                    this.baselineDelta = 0;
                }
                Object.defineProperty(BulletChart.prototype, "reverse", {
                    get: function () {
                        return this.model.bulletChartSettings.orientation.reverse;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(BulletChart.prototype, "vertical", {
                    get: function () {
                        return this.model.bulletChartSettings.orientation.vertical;
                    },
                    enumerable: true,
                    configurable: true
                });
                BulletChart.DefaultStyleProperties = function () {
                    return {
                        values: {
                            targetValue: 0,
                            targetValue2: 0,
                            minimumPercent: 0,
                            needsImprovementPercent: 25,
                            satisfactoryPercent: 50,
                            goodPercent: 100,
                            veryGoodPercent: 125,
                            maximumPercent: 200,
                        },
                        orientation: {
                            orientation: Orientation.HORIZONTALLEFT,
                            reverse: false,
                            vertical: false
                        },
                        colors: {
                            badColor: 'Darkred',
                            needsImprovementColor: 'Red',
                            satisfactoryColor: 'Yellow',
                            goodColor: 'Green',
                            veryGoodColor: 'Darkgreen',
                            bulletColor: 'Black'
                        },
                        axis: {
                            axis: true,
                            axisColor: 'Grey',
                            measureUnits: '',
                            unitsColor: 'Grey',
                        },
                        labelSettings: {
                            fontSize: 11,
                            show: true,
                            labelColor: 'Black',
                        },
                    };
                };
                Object.defineProperty(BulletChart.prototype, "viewportIn", {
                    get: function () {
                        return {
                            width: this.viewport.width,
                            height: this.viewport.height
                        };
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(BulletChart.prototype, "viewportScroll", {
                    get: function () {
                        var viewportIn = this.viewportIn;
                        return {
                            width: viewportIn.width - BulletChart.ScrollBarSize,
                            height: viewportIn.height - BulletChart.ScrollBarSize
                        };
                    },
                    enumerable: true,
                    configurable: true
                });
                BulletChart.getTextProperties = function (text, fontSize) {
                    return {
                        fontFamily: BulletChart.FontFamily,
                        fontSize: PixelConverter.fromPoint(fontSize),
                        text: text,
                    };
                };
                BulletChart.converter = function (dataView, options) {
                    var defaultSettings = BulletChart.DefaultStyleProperties();
                    var bulletModel = {
                        bulletValueFormatString: null,
                        bulletChartSettings: defaultSettings,
                        bars: [],
                        barRects: [],
                        valueRects: [],
                        targetValues: [],
                    };
                    if (!dataView || !dataView.categorical || !dataView.categorical.categories || !dataView.categorical.values || dataView.categorical.values.length === 0
                        || !dataView.metadata || !dataView.metadata.columns || dataView.metadata.columns.length === 0) {
                        return bulletModel;
                    }
                    var objects = dataView.metadata.objects;
                    var settings = bulletModel.bulletChartSettings;
                    if (objects) {
                        settings.values.targetValue = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.values.targetValue, defaultSettings.values.targetValue);
                        settings.values.targetValue2 = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.values.targetValue2, defaultSettings.values.targetValue2);
                        settings.values.minimumPercent = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.values.minimumPercent, defaultSettings.values.minimumPercent);
                        settings.values.needsImprovementPercent = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.values.needsImprovementPercent, defaultSettings.values.needsImprovementPercent);
                        settings.values.satisfactoryPercent = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.values.satisfactoryPercent, defaultSettings.values.satisfactoryPercent);
                        settings.values.goodPercent = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.values.goodPercent, defaultSettings.values.goodPercent);
                        settings.values.veryGoodPercent = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.values.veryGoodPercent, defaultSettings.values.veryGoodPercent);
                        settings.values.maximumPercent = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.values.maximumPercent, defaultSettings.values.maximumPercent);
                        settings.orientation.orientation = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.orientation.orientation, defaultSettings.orientation.orientation);
                        settings.colors.badColor = powerbi.DataViewObjects.getFillColor(objects, BulletChart1443347686880.bulletChartProps.colors.badColor, defaultSettings.colors.badColor);
                        settings.colors.needsImprovementColor = powerbi.DataViewObjects.getFillColor(objects, BulletChart1443347686880.bulletChartProps.colors.needsImprovementColor, defaultSettings.colors.needsImprovementColor);
                        settings.colors.satisfactoryColor = powerbi.DataViewObjects.getFillColor(objects, BulletChart1443347686880.bulletChartProps.colors.satisfactoryColor, defaultSettings.colors.satisfactoryColor);
                        settings.colors.goodColor = powerbi.DataViewObjects.getFillColor(objects, BulletChart1443347686880.bulletChartProps.colors.goodColor, defaultSettings.colors.goodColor);
                        settings.colors.veryGoodColor = powerbi.DataViewObjects.getFillColor(objects, BulletChart1443347686880.bulletChartProps.colors.veryGoodColor, defaultSettings.colors.veryGoodColor);
                        settings.colors.bulletColor = powerbi.DataViewObjects.getFillColor(objects, BulletChart1443347686880.bulletChartProps.colors.bulletColor, defaultSettings.colors.bulletColor);
                        settings.axis.axis = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.axis.axis, defaultSettings.axis.axis);
                        settings.axis.axisColor = powerbi.DataViewObjects.getFillColor(objects, BulletChart1443347686880.bulletChartProps.axis.axisColor, defaultSettings.axis.axisColor);
                        settings.axis.measureUnits = powerbi.TextMeasurementService.getTailoredTextOrDefault(BulletChart.getTextProperties(powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.axis.measureUnits, defaultSettings.axis.measureUnits), BulletChart.DefaultSubtitleFontSizeInPt), BulletChart.MaxLabelWidth);
                        settings.axis.unitsColor = powerbi.DataViewObjects.getFillColor(objects, BulletChart1443347686880.bulletChartProps.axis.unitsColor, defaultSettings.axis.unitsColor);
                        settings.labelSettings.fontSize = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.labels.fontSize, defaultSettings.labelSettings.fontSize);
                        settings.labelSettings.show = powerbi.DataViewObjects.getValue(objects, BulletChart1443347686880.bulletChartProps.labels.show, defaultSettings.labelSettings.show);
                        settings.labelSettings.labelColor = powerbi.DataViewObjects.getFillColor(objects, BulletChart1443347686880.bulletChartProps.labels.labelColor, defaultSettings.labelSettings.labelColor);
                    }
                    if (settings.orientation.orientation === Orientation.HORIZONTALRIGHT || settings.orientation.orientation === Orientation.VERTICALBOTTOM)
                        settings.orientation.reverse = true;
                    if (settings.orientation.orientation === Orientation.VERTICALTOP || settings.orientation.orientation === Orientation.VERTICALBOTTOM)
                        settings.orientation.vertical = true;
                    var categories, categoryValues, categoryValuesLen = 1, categoryFormatString;
                    if (dataView.categorical.categories) {
                        categories = dataView.categorical.categories[0];
                        categoryValues = categories.values;
                        categoryValuesLen = categoryValues.length;
                        categoryFormatString = visuals.valueFormatter.getFormatString(categories.source, BulletChart1443347686880.bulletChartProps.formatString);
                    }
                    bulletModel.bulletValueFormatString = visuals.valueFormatter.getFormatString(dataView.categorical.values[0].source, BulletChart1443347686880.bulletChartProps.formatString);
                    for (var idx = 0; idx < categoryValuesLen; idx++) {
                        var toolTipItems = [];
                        var category = void 0, value = void 0, targetValue = void 0, targetValue2 = void 0, minimum = void 0, satisfactory = void 0, good = void 0, maximum = void 0, needsImprovement = void 0, veryGood = void 0;
                        var highlight = false, categoryIdentity = void 0;
                        if (categoryValues) {
                            var categoryValue = categoryValues[idx];
                            category = visuals.valueFormatter.format(categoryValue, categoryFormatString);
                            categoryIdentity = categories.identity ? categories.identity[idx] : null;
                            var textProperties = BulletChart.getTextProperties(category, settings.labelSettings.fontSize);
                            category = powerbi.TextMeasurementService.getTailoredTextOrDefault(textProperties, BulletChart.MaxLabelWidth - BulletChart.StartMarginHorizontal);
                            var labelWidth = powerbi.TextMeasurementService.measureSvgTextWidth(textProperties);
                            var labelHeight = powerbi.TextMeasurementService.estimateSvgTextHeight(textProperties);
                            BulletChart.BiggestLabelWidth = Math.max(BulletChart.BiggestLabelWidth, labelWidth);
                            BulletChart.BiggestLabelHeight = Math.max(BulletChart.BiggestLabelHeight, labelHeight);
                        }
                        var values = dataView.categorical.values;
                        targetValue = settings.values.targetValue;
                        targetValue2 = settings.values.targetValue2;
                        for (var i = 0; i < values.length; i++) {
                            var col = values[i].source;
                            var currentVal = values[i].values[idx] || 0;
                            if (col && col.roles) {
                                if (col.roles[BulletChart1443347686880.bulletChartRoleNames.value]) {
                                    if (values[i].highlights)
                                        highlight = values[i].highlights[idx] !== null;
                                    toolTipItems.push({ value: currentVal, metadata: values[i] });
                                    value = currentVal;
                                }
                                else if (col.roles[BulletChart1443347686880.bulletChartRoleNames.targetValue]) {
                                    toolTipItems.push({ value: currentVal, metadata: values[i] });
                                    targetValue = currentVal;
                                }
                                else if (col.roles[BulletChart1443347686880.bulletChartRoleNames.targetValue2]) {
                                    toolTipItems.push({ value: currentVal, metadata: values[i] });
                                    targetValue2 = currentVal;
                                }
                                else if (col.roles[BulletChart1443347686880.bulletChartRoleNames.minValue])
                                    minimum = currentVal;
                                else if (col.roles[BulletChart1443347686880.bulletChartRoleNames.needsImprovementValue])
                                    needsImprovement = currentVal;
                                else if (col.roles[BulletChart1443347686880.bulletChartRoleNames.satisfactoryValue])
                                    satisfactory = currentVal;
                                else if (col.roles[BulletChart1443347686880.bulletChartRoleNames.goodValue])
                                    good = currentVal;
                                else if (col.roles[BulletChart1443347686880.bulletChartRoleNames.veryGoodValue])
                                    veryGood = currentVal;
                                else if (col.roles[BulletChart1443347686880.bulletChartRoleNames.maxValue])
                                    maximum = currentVal;
                            }
                        }
                        if (!minimum)
                            minimum = settings.values.minimumPercent * targetValue / 100;
                        if (!needsImprovement)
                            needsImprovement = settings.values.needsImprovementPercent * targetValue / 100;
                        if (!satisfactory)
                            satisfactory = settings.values.satisfactoryPercent * targetValue / 100;
                        if (!good)
                            good = settings.values.goodPercent * targetValue / 100;
                        if (!veryGood)
                            veryGood = settings.values.veryGoodPercent * targetValue / 100;
                        if (!maximum)
                            maximum = settings.values.maximumPercent * targetValue / 100;
                        var viewportLength = (settings.orientation.vertical ? (options.viewport.height - BulletChart.MaxLabelHeight) : (options.viewport.width - BulletChart.MaxLabelWidth)) -
                            BulletChart.StartMarginHorizontal - BulletChart.ScrollBarSize;
                        var sortedRanges = [minimum, needsImprovement, satisfactory, good, veryGood, maximum].sort(d3.descending);
                        var scale = (d3.scale.linear()
                            .clamp(true)
                            .domain([minimum, Math.max(sortedRanges[0], targetValue, value)])
                            .range(settings.orientation.vertical ? [viewportLength, 0] : [0, viewportLength]));
                        var firstScale = scale(minimum);
                        var secondScale = scale(needsImprovement);
                        var thirdScale = scale(satisfactory);
                        var fourthScale = scale(good);
                        var fifthScale = scale(veryGood);
                        var lastScale = scale(maximum);
                        var valueScale = scale(value);
                        var firstColor = settings.colors.badColor, secondColor = settings.colors.needsImprovementColor, thirdColor = settings.colors.satisfactoryColor, fourthColor = settings.colors.goodColor, lastColor = settings.colors.veryGoodColor;
                        BulletChart.addItemToBarArray(bulletModel.barRects, idx, firstScale, secondScale, firstColor, toolTipItems, categoryIdentity);
                        BulletChart.addItemToBarArray(bulletModel.barRects, idx, secondScale, thirdScale, secondColor, toolTipItems, categoryIdentity);
                        BulletChart.addItemToBarArray(bulletModel.barRects, idx, thirdScale, fourthScale, thirdColor, toolTipItems, categoryIdentity);
                        BulletChart.addItemToBarArray(bulletModel.barRects, idx, fourthScale, fifthScale, fourthColor, toolTipItems, categoryIdentity);
                        BulletChart.addItemToBarArray(bulletModel.barRects, idx, fifthScale, lastScale, lastColor, toolTipItems, categoryIdentity);
                        BulletChart.addItemToBarArray(bulletModel.valueRects, idx, firstScale, valueScale, settings.colors.bulletColor, toolTipItems, categoryIdentity);
                        bulletModel.targetValues.push({
                            barIndex: idx,
                            value: scale(targetValue),
                            fill: settings.colors.bulletColor,
                            key: visuals.SelectionId.createWithIdAndMeasure(categoryIdentity, scale(targetValue).toString()).getKey(),
                            value2: scale(targetValue2),
                        });
                        var xAxis = null;
                        if (settings.axis.axis) {
                            xAxis = d3.svg.axis();
                            xAxis.orient(settings.orientation.vertical ? "left" : "bottom");
                            var minTickSize = Math.round(Math.max(3, viewportLength / 100));
                            var axisValues = [value, targetValue, good, satisfactory, maximum, minimum, needsImprovement, veryGood]
                                .filter(function (x) { return !isNaN(x); });
                            xAxis.tickFormat(visuals.valueFormatter.create({
                                format: bulletModel.bulletValueFormatString,
                                value: axisValues.length ? Math.max.apply(null, axisValues) : 0
                            }).format);
                            xAxis.ticks(minTickSize);
                            xAxis.scale(scale);
                        }
                        var bar = {
                            scale: scale,
                            barIndex: idx,
                            categoryLabel: category,
                            x: (settings.orientation.vertical) ? BulletChart.StartMarginVertical + BulletChart.SpaceRequiredForBarVertically * idx : BulletChart.StartMarginHorizontal,
                            y: (settings.orientation.vertical) ? BulletChart.StartMarginVertical : BulletChart.StartMarginHorizontal + BulletChart.SpaceRequiredForBar * idx,
                            axis: xAxis,
                            key: visuals.SelectionId.createWithIdAndMeasure(categoryIdentity, idx.toString()).getKey(),
                        };
                        bulletModel.bars.push(bar);
                    }
                    return bulletModel;
                };
                BulletChart.addItemToBarArray = function (collection, barIndex, start, end, fill, tooltipInfo, categoryIdentity) {
                    collection.push({
                        barIndex: barIndex,
                        start: start,
                        end: end,
                        fill: fill,
                        tooltipInfo: visuals.TooltipBuilder.createTooltipInfo(BulletChart1443347686880.bulletChartProps.formatString, null, null, null, null, tooltipInfo),
                        selected: false,
                        identity: visuals.SelectionId.createWithId(categoryIdentity),
                        key: visuals.SelectionId.createWithIdAndMeasure(categoryIdentity, start + " " + end).getKey(),
                    });
                };
                BulletChart.prototype.init = function (options) {
                    var body = d3.select(options.element.get(0));
                    this.hostService = options.host;
                    this.bulletBody = body
                        .append('div')
                        .classed('bulletChart', true);
                    this.scrollContainer = this.bulletBody.append('svg')
                        .classed('bullet-scroll-region', true);
                    this.clearCatcher = visuals.appendClearCatcher(this.scrollContainer);
                    this.labelGraphicsContext = this.scrollContainer.append('g');
                    this.bulletGraphicsContext = this.scrollContainer.append('g');
                    this.behavior = new BulletWebBehavior();
                    this.interactivityService = visuals.createInteractivityService(options.host);
                };
                BulletChart.prototype.update = function (options) {
                    if (!options.dataViews || !options.dataViews[0])
                        return;
                    BulletChart.BiggestLabelHeight = BulletChart.BiggestLabelWidth = 0;
                    var dataView = options.dataViews[0];
                    this.viewport = options.viewport;
                    this.model = BulletChart.converter(dataView, options);
                    this.baselineDelta = TextMeasurementHelper.estimateSvgTextBaselineDelta(BulletChart.getTextProperties("1", this.model.bulletChartSettings.labelSettings.fontSize));
                    this.ClearViewport();
                    if (!this.model) {
                        return;
                    }
                    if (this.interactivityService) {
                        this.interactivityService.applySelectionStateToData(this.model.barRects);
                    }
                    this.bulletBody.style({
                        'height': this.viewportIn.height + 'px',
                        'width': this.viewportIn.width + 'px',
                    });
                    if (this.vertical) {
                        this.scrollContainer.attr({
                            width: (this.model.bars.length * BulletChart.SpaceRequiredForBarVertically) + 'px',
                            height: this.viewportScroll.height + 'px'
                        });
                    }
                    else {
                        this.scrollContainer.attr({
                            height: (this.model.bars.length * BulletChart.SpaceRequiredForBar) + 'px',
                            width: this.viewportScroll.width + 'px'
                        });
                    }
                    if (this.vertical)
                        this.setUpBulletsVertically(this.bulletBody, this.model, this.reverse);
                    else
                        this.setUpBulletsHorizontally(this.bulletBody, this.model, this.reverse);
                };
                BulletChart.prototype.ClearViewport = function () {
                    this.labelGraphicsContext.selectAll("text").remove();
                    this.bulletGraphicsContext.selectAll("rect").remove();
                    this.bulletGraphicsContext.selectAll('axis').remove();
                    this.bulletGraphicsContext.selectAll('path').remove();
                    this.bulletGraphicsContext.selectAll('line').remove();
                    this.bulletGraphicsContext.selectAll('tick').remove();
                    this.bulletGraphicsContext.selectAll('g').remove();
                };
                BulletChart.prototype.calculateLabelWidth = function (barData, bar, reversed) {
                    if (reversed)
                        return BulletChart.StartMarginHorizontal + ((bar) ? bar.start : 0);
                    var textSize = powerbi.TextMeasurementService.measureSvgTextWidth(BulletChart.getTextProperties(barData.categoryLabel, this.model.bulletChartSettings.labelSettings.fontSize));
                    if (textSize > BulletChart.BiggestLabelWidth)
                        return barData.x + BulletChart.MaxLabelWidth + ((bar) ? bar.start : 0);
                    return barData.x + BulletChart.BiggestLabelWidth + BulletChart.BarMargin + ((bar) ? bar.start : 0);
                };
                BulletChart.prototype.calculateLabelHeight = function (barData, bar, reversed) {
                    if (reversed)
                        return BulletChart.StartMarginVertical + ((bar) ? bar.end : 0);
                    var textSize = powerbi.TextMeasurementService.measureSvgTextHeight(BulletChart.getTextProperties(barData.categoryLabel, this.model.bulletChartSettings.labelSettings.fontSize));
                    if (textSize > BulletChart.BiggestLabelHeight)
                        return barData.y + BulletChart.MaxLabelHeight + ((bar) ? bar.end : 0);
                    return barData.y + textSize + BulletChart.BarMargin + ((bar) ? bar.end : 0);
                };
                BulletChart.prototype.setUpBulletsHorizontally = function (bulletBody, model, reveresed) {
                    var _this = this;
                    var bars = model.bars;
                    var rects = model.barRects;
                    var valueRects = model.valueRects;
                    var targetValues = model.targetValues;
                    var barSelection = this.labelGraphicsContext.selectAll('text').data(bars, function (d) { return d.key; });
                    var rectSelection = this.bulletGraphicsContext.selectAll('rect.range').data(rects, function (d) { return d.key; });
                    var bullets = rectSelection.enter().append('rect').attr({
                        'x': (function (d) { return _this.calculateLabelWidth(bars[d.barIndex], d, reveresed); }),
                        'y': (function (d) { return bars[d.barIndex].y - BulletChart.BulletSize / 2; }),
                        'width': (function (d) { return d.end - d.start; }),
                        'height': BulletChart.BulletSize,
                    }).classed('range', true).style({
                        'fill': (function (d) { return d.fill; })
                    });
                    rectSelection.exit();
                    var valueSelection = this.bulletGraphicsContext.selectAll('rect').data(valueRects, function (d) { return d.key; });
                    valueSelection.enter().append('rect').attr({
                        'x': (function (d) { return _this.calculateLabelWidth(bars[d.barIndex], d, reveresed); }),
                        'y': (function (d) { return bars[d.barIndex].y - BulletChart.BulletSize / 8; }),
                        'width': (function (d) { return d.end - d.start; }),
                        'height': BulletChart.BulletSize * 1 / 4,
                    }).classed('value', true).style({
                        'fill': (function (d) { return d.fill; }),
                    });
                    valueSelection.exit();
                    var markerSelection = this.bulletGraphicsContext.selectAll('values').data(targetValues, function (d) { return d.key; });
                    markerSelection.enter().append('line').attr({
                        'x1': (function (d) { return _this.calculateLabelWidth(bars[d.barIndex], null, reveresed) + d.value; }),
                        'x2': (function (d) { return _this.calculateLabelWidth(bars[d.barIndex], null, reveresed) + d.value; }),
                        'y1': (function (d) { return bars[d.barIndex].y - BulletChart.MarkerMarginHorizontal; }),
                        'y2': (function (d) { return bars[d.barIndex].y + BulletChart.MarkerMarginHorizontal; }),
                    }).style({
                        'stroke': (function (d) { return d.fill; }),
                        'stroke-width': 2,
                    });
                    markerSelection.enter().append('line').attr({
                        'x1': (function (d) { return _this.calculateLabelWidth(bars[d.barIndex], null, reveresed) + d.value2; }),
                        'x2': (function (d) { return _this.calculateLabelWidth(bars[d.barIndex], null, reveresed) + d.value2; }),
                        'y1': (function (d) { return bars[d.barIndex].y - BulletChart.MarkerMarginHorizontal; }),
                        'y2': (function (d) { return bars[d.barIndex].y + BulletChart.MarkerMarginHorizontal; }),
                    }).style({
                        'stroke': (function (d) { return d.fill; }),
                        'stroke-width': 2,
                        'transform': 'rotate(45deg)',
                        'transform-origin': '50% 50% 0',
                    });
                    markerSelection.enter().append('line').attr({
                        'x1': (function (d) { return _this.calculateLabelWidth(bars[d.barIndex], null, reveresed) + d.value2; }),
                        'x2': (function (d) { return _this.calculateLabelWidth(bars[d.barIndex], null, reveresed) + d.value2; }),
                        'y1': (function (d) { return bars[d.barIndex].y - BulletChart.MarkerMarginHorizontal; }),
                        'y2': (function (d) { return bars[d.barIndex].y + BulletChart.MarkerMarginHorizontal; }),
                    }).style({
                        'stroke': (function (d) { return d.fill; }),
                        'stroke-width': 2,
                        'transform': 'rotate(315deg)',
                        'transform-origin': '50% 50% 0',
                    });
                    markerSelection.exit();
                    if (model.bulletChartSettings.axis.axis) {
                        for (var idx = 0; idx < bars.length; idx++) {
                            var bar = bars[idx];
                            this.bulletGraphicsContext.append("g").attr({
                                'transform': function () {
                                    var xLocation = _this.calculateLabelWidth(bar, null, reveresed);
                                    var yLocation = bar.y + BulletChart.BulletSize / 2;
                                    return 'translate(' + xLocation + ',' + yLocation + ')';
                                },
                            }).classed("axis", true).call(bar.axis.scale(bar.scale)).style({
                                'fill': model.bulletChartSettings.axis.axisColor,
                                'font-size': PixelConverter.fromPoint(BulletChart.AxisFontSizeInPt)
                            }).selectAll('line').style({
                                'stroke': model.bulletChartSettings.axis.axisColor,
                            });
                        }
                    }
                    if (model.bulletChartSettings.labelSettings.show) {
                        barSelection.enter().append('text').classed("title", true).attr({
                            'x': (function (d) {
                                if (reveresed)
                                    return _this.bulletGraphicsContext.node().getBoundingClientRect().width + BulletChart.StartMarginHorizontal;
                                return d.x;
                            }),
                            'y': (function (d) { return d.y + _this.baselineDelta; }),
                            'fill': model.bulletChartSettings.labelSettings.labelColor,
                            'font-size': PixelConverter.fromPoint(model.bulletChartSettings.labelSettings.fontSize),
                        }).text(function (d) { return d.categoryLabel; });
                    }
                    if (model.bulletChartSettings.axis.measureUnits) {
                        barSelection.enter().append('text').attr({
                            'x': (function (d) {
                                if (reveresed)
                                    return _this.bulletGraphicsContext.node().getBoundingClientRect().width - BulletChart.StartMarginHorizontal + BulletChart.SubtitleMargin;
                                return d.x - BulletChart.SubtitleMargin;
                            }),
                            'y': (function (d) { return d.y + BulletChart.BulletSize; }),
                            'fill': model.bulletChartSettings.axis.unitsColor,
                            'font-size': PixelConverter.fromPoint(BulletChart.DefaultSubtitleFontSizeInPt)
                        }).text(model.bulletChartSettings.axis.measureUnits);
                    }
                    if (this.interactivityService) {
                        var behaviorOptions = {
                            rects: bullets,
                            valueRects: valueSelection,
                            clearCatcher: this.clearCatcher,
                            interactivityService: this.interactivityService,
                            bulletChartSettings: this.model.bulletChartSettings,
                            hasHighlights: false,
                        };
                        var targetCollection = this.model.barRects.concat(this.model.valueRects);
                        this.interactivityService.bind(targetCollection, this.behavior, behaviorOptions);
                    }
                    barSelection.exit();
                    visuals.TooltipManager.addTooltip(valueSelection, function (tooltipEvent) { return tooltipEvent.data.tooltipInfo; }, true);
                    visuals.TooltipManager.addTooltip(rectSelection, function (tooltipEvent) { return tooltipEvent.data.tooltipInfo; }, true);
                };
                BulletChart.prototype.setUpBulletsVertically = function (bulletBody, model, reveresed) {
                    var _this = this;
                    var bars = model.bars;
                    var rects = model.barRects;
                    var valueRects = model.valueRects;
                    var targetValues = model.targetValues;
                    var barSelection = this.labelGraphicsContext.selectAll('text').data(bars, function (d) { return d.key; });
                    var rectSelection = this.bulletGraphicsContext.selectAll('rect.range').data(rects, function (d) { return d.key; });
                    var bullets = rectSelection.enter().append('rect').attr({
                        'x': (function (d) { return bars[d.barIndex].x; }),
                        'y': (function (d) { return _this.calculateLabelHeight(bars[d.barIndex], d, reveresed); }),
                        'height': (function (d) { return d.start - d.end; }),
                        'width': BulletChart.BulletSize,
                    }).classed('range', true).style({
                        'fill': (function (d) { return d.fill; })
                    });
                    rectSelection.exit();
                    var valueSelection = this.bulletGraphicsContext.selectAll('rect').data(valueRects, function (d) { return d.key; });
                    valueSelection.enter().append('rect').attr({
                        'x': (function (d) { return bars[d.barIndex].x + BulletChart.BulletSize / 3; }),
                        'y': (function (d) { return _this.calculateLabelHeight(bars[d.barIndex], d, reveresed); }),
                        'height': (function (d) { return d.start - d.end; }),
                        'width': BulletChart.BulletSize * 1 / 4,
                    }).classed('value', true).style({
                        'fill': (function (d) { return d.fill; }),
                    });
                    valueSelection.exit();
                    var markerSelection = this.bulletGraphicsContext.selectAll('values').data(targetValues, function (d) { return d.key; });
                    markerSelection.enter().append('line').attr({
                        'x2': (function (d) { return bars[d.barIndex].x + (BulletChart.MarkerMarginVertical * 3); }),
                        'x1': (function (d) { return bars[d.barIndex].x + BulletChart.MarkerMarginVertical; }),
                        'y2': (function (d) { return _this.calculateLabelHeight(bars[d.barIndex], null, reveresed) + d.value; }),
                        'y1': (function (d) { return _this.calculateLabelHeight(bars[d.barIndex], null, reveresed) + d.value; }),
                    }).style({
                        'stroke': (function (d) { return d.fill; }),
                        'stroke-width': 2,
                    });
                    markerSelection.enter().append('line').attr({
                        'y1': (function (d) { return _this.calculateLabelHeight(bars[d.barIndex], null, reveresed) + d.value2; }),
                        'y2': (function (d) { return _this.calculateLabelHeight(bars[d.barIndex], null, reveresed) + d.value2; }),
                        'x1': (function (d) { return bars[d.barIndex].x + BulletChart.MarkerMarginVertical; }),
                        'x2': (function (d) { return bars[d.barIndex].x + (BulletChart.MarkerMarginVertical * 3); }),
                    }).style({
                        'stroke': (function (d) { return d.fill; }),
                        'stroke-width': 2,
                        'transform': 'rotate(45deg)',
                        'transform-origin': '50% 50% 0',
                    });
                    markerSelection.enter().append('line').attr({
                        'y1': (function (d) { return _this.calculateLabelHeight(bars[d.barIndex], null, reveresed) + d.value2; }),
                        'y2': (function (d) { return _this.calculateLabelHeight(bars[d.barIndex], null, reveresed) + d.value2; }),
                        'x1': (function (d) { return bars[d.barIndex].x + BulletChart.MarkerMarginVertical; }),
                        'x2': (function (d) { return bars[d.barIndex].x + (BulletChart.MarkerMarginVertical * 3); }),
                    }).style({
                        'stroke': (function (d) { return d.fill; }),
                        'stroke-width': 2,
                        'transform': 'rotate(315deg)',
                        'transform-origin': '50% 50% 0',
                    });
                    markerSelection.exit();
                    if (model.bulletChartSettings.axis.axis) {
                        for (var idx = 0; idx < bars.length; idx++) {
                            var bar = bars[idx];
                            this.bulletGraphicsContext.append("g").attr({
                                'transform': function () {
                                    var xLocation = bar.x;
                                    var yLocation = _this.calculateLabelHeight(bar, null, reveresed);
                                    return 'translate(' + xLocation + ',' + yLocation + ')';
                                },
                            }).classed("axis", true).call(bar.axis.scale(bar.scale)).style({
                                'fill': model.bulletChartSettings.axis.axisColor,
                                'font-size': PixelConverter.fromPoint(BulletChart.AxisFontSizeInPt),
                            }).selectAll('line').style({
                                'stroke': model.bulletChartSettings.axis.axisColor,
                            });
                        }
                    }
                    if (model.bulletChartSettings.labelSettings.show) {
                        barSelection.enter().append('text').classed("title", true).attr({
                            'x': (function (d) { return d.x; }),
                            'y': (function (d) {
                                if (reveresed)
                                    return _this.bulletGraphicsContext.node().getBoundingClientRect().height + BulletChart.StartMarginVertical + BulletChart.BulletSize;
                                return d.y + powerbi.TextMeasurementService.estimateSvgTextHeight(BulletChart.getTextProperties(d.categoryLabel, model.bulletChartSettings.labelSettings.fontSize)) / 2;
                            }),
                            'fill': model.bulletChartSettings.labelSettings.labelColor,
                            'font-size': PixelConverter.fromPoint(model.bulletChartSettings.labelSettings.fontSize),
                        }).text(function (d) { return d.categoryLabel; });
                    }
                    if (model.bulletChartSettings.axis.measureUnits) {
                        barSelection.enter().append('text').attr({
                            'x': (function (d) { return d.x + BulletChart.BulletSize; }),
                            'y': (function (d) {
                                if (reveresed)
                                    return _this.bulletGraphicsContext.node().getBoundingClientRect().height + BulletChart.StartMarginVertical + BulletChart.SubtitleMargin;
                                return d.y + BulletChart.StartMarginVertical + BulletChart.SubtitleMargin;
                            }),
                            'fill': model.bulletChartSettings.axis.unitsColor,
                            'font-size': PixelConverter.fromPoint(BulletChart.DefaultSubtitleFontSizeInPt)
                        }).text(model.bulletChartSettings.axis.measureUnits);
                    }
                    if (this.interactivityService) {
                        var behaviorOptions = {
                            rects: bullets,
                            valueRects: valueSelection,
                            clearCatcher: this.clearCatcher,
                            interactivityService: this.interactivityService,
                            bulletChartSettings: this.model.bulletChartSettings,
                            hasHighlights: false,
                        };
                        var targetCollection = this.model.barRects.concat(this.model.valueRects);
                        this.interactivityService.bind(targetCollection, this.behavior, behaviorOptions);
                    }
                    barSelection.exit();
                    visuals.TooltipManager.addTooltip(valueSelection, function (tooltipEvent) { return tooltipEvent.data.tooltipInfo; }, true);
                    visuals.TooltipManager.addTooltip(rectSelection, function (tooltipEvent) { return tooltipEvent.data.tooltipInfo; }, true);
                };
                BulletChart.prototype.destroy = function () { };
                BulletChart.prototype.enumerateObjectInstances = function (options) {
                    var data = this.model;
                    if (!data) {
                        return;
                    }
                    var objectName = options.objectName;
                    switch (objectName) {
                        case 'labels':
                            return this.enumerateLabels(data);
                        case 'values':
                            return this.enumerateValues(data);
                        case 'orientation':
                            return this.enumerateOrientation(data);
                        case 'axis':
                            return this.enumerateAxis(data);
                        case 'colors':
                            return this.enumerateColors(data);
                    }
                };
                BulletChart.prototype.enumerateLabels = function (data) {
                    return [{
                            selector: null,
                            objectName: 'labels',
                            properties: {
                                show: this.model.bulletChartSettings.labelSettings.show,
                                labelColor: this.model.bulletChartSettings.labelSettings.labelColor,
                                fontSize: this.model.bulletChartSettings.labelSettings.fontSize,
                            }
                        }];
                };
                BulletChart.prototype.enumerateValues = function (data) {
                    return [{
                            selector: null,
                            objectName: 'values',
                            properties: {
                                targetValue: this.model.bulletChartSettings.values.targetValue,
                                targetValue2: this.model.bulletChartSettings.values.targetValue2,
                                minimumPercent: this.model.bulletChartSettings.values.minimumPercent,
                                needsImprovementPercent: this.model.bulletChartSettings.values.needsImprovementPercent,
                                satisfactoryPercent: this.model.bulletChartSettings.values.satisfactoryPercent,
                                goodPercent: this.model.bulletChartSettings.values.goodPercent,
                                veryGoodPercent: this.model.bulletChartSettings.values.veryGoodPercent,
                                maximumPercent: this.model.bulletChartSettings.values.maximumPercent,
                            }
                        }];
                };
                BulletChart.prototype.enumerateOrientation = function (data) {
                    return [{
                            selector: null,
                            objectName: 'orientation',
                            properties: {
                                orientation: this.model.bulletChartSettings.orientation.orientation
                            }
                        }];
                };
                BulletChart.prototype.enumerateAxis = function (data) {
                    return [{
                            selector: null,
                            objectName: 'axis',
                            properties: {
                                axis: this.model.bulletChartSettings.axis.axis,
                                axisColor: this.model.bulletChartSettings.axis.axisColor,
                                measureUnits: this.model.bulletChartSettings.axis.measureUnits,
                                unitsColor: this.model.bulletChartSettings.axis.unitsColor,
                            }
                        }];
                };
                BulletChart.prototype.enumerateColors = function (data) {
                    return [{
                            selector: null,
                            objectName: 'colors',
                            properties: {
                                badColor: this.model.bulletChartSettings.colors.badColor,
                                needsImprovementColor: this.model.bulletChartSettings.colors.needsImprovementColor,
                                satisfactoryColor: this.model.bulletChartSettings.colors.satisfactoryColor,
                                goodColor: this.model.bulletChartSettings.colors.goodColor,
                                veryGoodColor: this.model.bulletChartSettings.colors.veryGoodColor,
                                bulletColor: this.model.bulletChartSettings.colors.bulletColor,
                            }
                        }];
                };
                BulletChart.ScrollBarSize = 13;
                BulletChart.SpaceRequiredForBar = 60;
                BulletChart.SpaceRequiredForBarVertically = 100;
                BulletChart.StartMarginHorizontal = 30;
                BulletChart.StartMarginVertical = 50;
                BulletChart.BulletSize = 25;
                BulletChart.DefaultSubtitleFontSizeInPt = 9;
                BulletChart.BarMargin = 10;
                BulletChart.MaxLabelWidth = 80;
                BulletChart.MaxLabelHeight = 60;
                BulletChart.SubtitleMargin = 10;
                BulletChart.AxisFontSizeInPt = 8;
                BulletChart.BiggestLabelWidth = 0;
                BulletChart.BiggestLabelHeight = 0;
                BulletChart.MarkerMarginHorizontal = BulletChart.BulletSize / 3;
                BulletChart.MarkerMarginVertical = BulletChart.BulletSize / 4;
                BulletChart.FontFamily = "Segoe UI";
                BulletChart.capabilities = {
                    dataRoles: [
                        {
                            name: 'Category',
                            kind: powerbi.VisualDataRoleKind.Grouping,
                            displayName: 'Category',
                        }, {
                            name: 'Value',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Value',
                        }, {
                            name: 'TargetValue',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Target Value',
                        }, {
                            name: 'Minimum',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Minimum',
                        }, {
                            name: 'NeedsImprovement',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Needs Improvement',
                        }, {
                            name: 'Satisfactory',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Satisfactory',
                        }, {
                            name: 'Good',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Good',
                        }, {
                            name: 'VeryGood',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Very Good',
                        }, {
                            name: 'Maximum',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Maximum',
                        }, {
                            name: 'TargetValue2',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Target Value 2'
                        }
                    ],
                    objects: {
                        general: {
                            displayName: powerbi.data.createDisplayNameGetter('Visual_General'),
                            properties: {
                                formatString: {
                                    type: { formatting: { formatString: true } },
                                },
                            },
                        },
                        values: {
                            displayName: 'Data values',
                            properties: {
                                targetValue: {
                                    displayName: 'Target Value',
                                    type: { numeric: true }
                                },
                                targetValue2: {
                                    displayName: 'Target Value 2',
                                    type: { numeric: true },
                                },
                                minimumPercent: {
                                    displayName: 'Minimum %',
                                    type: { numeric: true }
                                },
                                needsImprovementPercent: {
                                    displayName: 'Needs Improvement %',
                                    type: { numeric: true },
                                },
                                satisfactoryPercent: {
                                    displayName: 'Satisfactory %',
                                    type: { numeric: true }
                                },
                                goodPercent: {
                                    displayName: 'Good %',
                                    type: { numeric: true }
                                },
                                veryGoodPercent: {
                                    displayName: 'Very Good %',
                                    type: { numeric: true },
                                },
                                maximumPercent: {
                                    displayName: 'Maximum %',
                                    type: { numeric: true }
                                },
                            }
                        },
                        labels: {
                            displayName: 'Category labels',
                            properties: {
                                show: {
                                    displayName: powerbi.data.createDisplayNameGetter('Visual_Show'),
                                    type: { bool: true },
                                },
                                labelColor: {
                                    displayName: powerbi.data.createDisplayNameGetter('Visual_LabelsFill'),
                                    description: powerbi.data.createDisplayNameGetter('Visual_LabelsFillDescription'),
                                    type: { fill: { solid: { color: true } } }
                                },
                                fontSize: {
                                    displayName: powerbi.data.createDisplayNameGetter('Visual_TextSize'),
                                    type: { formatting: { fontSize: true } },
                                },
                            },
                        },
                        orientation: {
                            displayName: 'Orientation',
                            properties: {
                                orientation: {
                                    displayName: 'Orientation',
                                    type: { enumeration: Orientation.type }
                                }
                            }
                        },
                        colors: {
                            displayName: 'Colors',
                            properties: {
                                badColor: {
                                    type: { fill: { solid: { color: true } } },
                                    displayName: 'Bad Color'
                                },
                                needsImprovementColor: {
                                    type: { fill: { solid: { color: true } } },
                                    displayName: 'Needs Improvement Color',
                                },
                                satisfactoryColor: {
                                    type: { fill: { solid: { color: true } } },
                                    displayName: 'Satisfactory Color'
                                },
                                goodColor: {
                                    type: { fill: { solid: { color: true } } },
                                    displayName: 'Good Color'
                                },
                                veryGoodColor: {
                                    type: { fill: { solid: { color: true } } },
                                    displayName: 'Very Good Color',
                                },
                                bulletColor: {
                                    type: { fill: { solid: { color: true } } },
                                    displayName: 'Bullet Color'
                                }
                            },
                        },
                        axis: {
                            displayName: 'Axis',
                            properties: {
                                axis: {
                                    displayName: 'Axis',
                                    type: { bool: true }
                                },
                                axisColor: {
                                    type: { fill: { solid: { color: true } } },
                                    displayName: 'Axis Color'
                                },
                                measureUnits: {
                                    type: { text: true },
                                    displayName: 'Measure Units '
                                },
                                unitsColor: {
                                    type: { fill: { solid: { color: true } } },
                                    displayName: 'Units Color'
                                },
                            }
                        }
                    },
                    dataViewMappings: [{
                            conditions: [
                                {
                                    'Category': { max: 1 }, 'Value': { max: 1 }, 'TargetValue': { max: 1 }, 'Minimum': { max: 1 }, 'NeedsImprovement': { max: 1 },
                                    'Satisfactory': { max: 1 }, 'Good': { max: 1 }, 'VeryGood': { max: 1 }, 'Maximum': { max: 1 }, 'TargetValue2': { max: 1 },
                                },
                            ],
                            categorical: {
                                categories: {
                                    for: { in: 'Category' },
                                    dataReductionAlgorithm: { top: {} }
                                },
                                values: {
                                    select: [
                                        { bind: { to: 'Value' } },
                                        { bind: { to: 'TargetValue' } },
                                        { bind: { to: 'TargetValue2' } },
                                        { bind: { to: 'Minimum' } },
                                        { bind: { to: 'NeedsImprovement' } },
                                        { bind: { to: 'Satisfactory' } },
                                        { bind: { to: 'Good' } },
                                        { bind: { to: 'VeryGood' } },
                                        { bind: { to: 'Maximum' } },
                                    ]
                                },
                            },
                        }],
                    supportsHighlight: true,
                    sorting: {
                        default: {},
                    },
                    drilldown: {
                        roles: ['Category']
                    }
                };
                return BulletChart;
            })();
            BulletChart1443347686880.BulletChart = BulletChart;
            var TextMeasurementHelper;
            (function (TextMeasurementHelper) {
                var spanElement;
                var svgTextElement;
                var canvasCtx;
                function estimateSvgTextBaselineDelta(textProperties) {
                    var rect = estimateSvgTextRect(textProperties);
                    return rect.y + rect.height;
                }
                TextMeasurementHelper.estimateSvgTextBaselineDelta = estimateSvgTextBaselineDelta;
                function ensureDOM() {
                    if (spanElement)
                        return;
                    spanElement = $('<span/>');
                    $('body').append(spanElement);
                    svgTextElement = d3.select($('body').get(0))
                        .append('svg')
                        .style({
                        'height': '0px',
                        'width': '0px',
                        'position': 'absolute'
                    })
                        .append('text');
                    canvasCtx = $('<canvas/>').get(0).getContext("2d");
                }
                function measureSvgTextRect(textProperties) {
                    debug.assertValue(textProperties, 'textProperties');
                    ensureDOM();
                    svgTextElement.style(null);
                    svgTextElement
                        .text(textProperties.text)
                        .attr({
                        'visibility': 'hidden',
                        'font-family': textProperties.fontFamily,
                        'font-size': textProperties.fontSize,
                        'font-weight': textProperties.fontWeight,
                        'font-style': textProperties.fontStyle,
                        'white-space': textProperties.whiteSpace || 'nowrap'
                    });
                    return svgTextElement.node().getBBox();
                }
                function estimateSvgTextRect(textProperties) {
                    debug.assertValue(textProperties, 'textProperties');
                    var estimatedTextProperties = {
                        fontFamily: textProperties.fontFamily,
                        fontSize: textProperties.fontSize,
                        text: "M",
                    };
                    var rect = measureSvgTextRect(estimatedTextProperties);
                    return rect;
                }
            })(TextMeasurementHelper = BulletChart1443347686880.TextMeasurementHelper || (BulletChart1443347686880.TextMeasurementHelper = {}));
            var BulletWebBehavior = (function () {
                function BulletWebBehavior() {
                }
                BulletWebBehavior.prototype.bindEvents = function (options, selectionHandler) {
                    this.options = options;
                    var clearCatcher = options.clearCatcher;
                    options.valueRects.on('click', function (d, i) {
                        d3.event.stopPropagation();
                        selectionHandler.handleSelection(d, d3.event.ctrlKey);
                    });
                    options.rects.on('click', function (d, i) {
                        d3.event.stopPropagation();
                        selectionHandler.handleSelection(d, d3.event.ctrlKey);
                    });
                    clearCatcher.on('click', function () {
                        selectionHandler.handleClearSelection();
                    });
                };
                BulletWebBehavior.prototype.renderSelection = function (hasSelection) {
                    var options = this.options;
                    options.valueRects.style("opacity", function (d) {
                        return hasSelection ? (d.selected ? '1' : '0.4') : '1';
                    });
                    options.rects.style("opacity", function (d) {
                        return hasSelection ? (d.selected ? '1' : '0.4') : '1';
                    });
                };
                return BulletWebBehavior;
            })();
            BulletChart1443347686880.BulletWebBehavior = BulletWebBehavior;
        })(BulletChart1443347686880 = visuals.BulletChart1443347686880 || (visuals.BulletChart1443347686880 = {}));
    })(visuals = powerbi.visuals || (powerbi.visuals = {}));
})(powerbi || (powerbi = {}));

var powerbi;
(function (powerbi) {
    var visuals;
    (function (visuals) {
        var plugins;
        (function (plugins) {
            plugins.BulletChart1443347686880 = {
                name: 'BulletChart1443347686880',
                class: 'BulletChart1443347686880',
                capabilities: powerbi.visuals.BulletChart1443347686880.BulletChart.capabilities,
                custom: true,
                create: function () { return new powerbi.visuals.BulletChart1443347686880.BulletChart(); }
            };
        })(plugins = visuals.plugins || (visuals.plugins = {}));
    })(visuals = powerbi.visuals || (powerbi.visuals = {}));
})(powerbi || (powerbi = {}));

//# sourceURL=BulletChart.js
//# sourceMappingURL=BulletChart1443347686880.js.map